local function calcNextRNG()
    local rng = memory.read_u16_le(0x1BE8)
    
    local x = bit.band(rng * 3, 0xFF00)
    local y = bit.band(bit.byteswap_16(x) + rng, 0x00FF)
    
    gui.text(0, 110, "next1: " .. y)
    gui.text(0, 125, "next2: " .. bit.byteswap_16(x))
    
    return x + y
end

while true do
    local rng = memory.read_u16_le(0x1BE8)
    local rng1 = memory.readbyte(0x1BE8)
    local rng2 = memory.readbyte(0x1BE9)
    local nextRngValue = calcNextRNG()
    
    gui.text(0, 50, "rng: " .. rng)
    gui.text(0, 65, "rng1: " .. rng1)
    gui.text(0, 80, "rng2: " .. rng2)
    gui.text(0, 95, "next: " .. nextRngValue)
    
    emu.frameadvance()
end